b10ef25405d3e75b0a6b16e4d33d1f6d2e0665c8
[automated-distro-installer] / fai / config / hooks / partition.DEFAULT
1 #!/bin/bash -x
2 # Copyright (C) 2016 Ian Kelling
3
4 # This program is free software; you can redistribute it and/or
5 # modify it under the terms of the GNU General Public License
6 # as published by the Free Software Foundation; either version 2
7 # of the License, or (at your option) any later version.
8
9 # This program is distributed in the hope that it will be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
12 # GNU General Public License for more details.
13
14 # You should have received a copy of the GNU General Public License
15 # along with this program; if not, write to the Free Software
16 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
17
18 set -eE -o pipefail
19 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
20
21 # for calling outside of FAI, first
22 # - source /a/bin/fai-wrapper
23 # - set any appropriate classes with: fai-setclass OPT1... which sets CLASS_OPT1=true...
24 # or run eval-fai-classfile FILE
25 #
26 # OPTIONS:
27 #
28 # environment variables:
29 #
30 # HOSTNAME: if frodo, we exclude 2 devices from the /boot array, which
31 # the bios does not see. if demohost, we set the luks password to just
32 # 'x'.
33 #
34 # SPECIAL_DISK: For use outside of fai. A base disk name like
35 # /dev/sdk. If set, we just cryptsetup and partition this one disk then
36 # exit. This is useful for partitioning a disk in preparation to replace
37 # a failed or failing disk from a raid10 array.
38 #
39 # classes:
40 #
41 # REPARTITION: forces repartitioning even if we detect the proper amount
42 # of partitions already exist.
43 #
44 # ROTATIONAL: forces to install onto hdds instead of sdds. normally sdds
45 # are chosen if they exist.
46 #
47 # PARTITION_PROMPT: command line prompt before partitioning
48 #
49 # RAID0: forces raid0 filesystem. Normally with 4+ devices, we use
50 # raid10.
51 # RAID1: forces raid1 filesystem.
52
53 if [[ $SPECIAL_DISK ]]; then
54 export CLASS_REPARTITION=true
55 fi
56
57 # # fai's setup-storage won't do btrfs on luks,
58 # # so we do it ourself :)
59 # inspiration taken from files in fai-setup-storage package
60
61 # if we are not running in fai, skiptask won't be defined, so carry on.
62 skiptask partition || ! type skiptask
63
64 if ! type -p devbyid; then
65 for d in $FAI/distro-install-common \
66 /a/bin/fai/fai/config/distro-install-common $FAI $PWD; do
67 [[ -d $d ]] || continue
68 if [[ -e $d/devbyid ]]; then
69 devbyid=$d/devbyid
70 devbyid() { $devbyid "$@"; }
71 break
72 fi
73 done
74 if [[ ! $devbyid ]]; then
75 echo "$0: error: failed to find devbyid script" >&2
76 exit 1
77 fi
78 fi
79
80
81
82 #### begin configuration
83
84 rootn=1
85 swapn=2
86 bootn=3
87 # ext partition so grub can write persistent variables,
88 # so it can do a one time boot. grub can't write to
89 # btrfs or any cow fs because it's more
90 # more complicated to do and they don't want to.
91 grub_extn=4
92 # bios boot partition,
93 # https://wiki.archlinux.org/index.php/GRUB
94 bios_grubn=5
95 lastn=$bios_grubn
96 # this is larger than needed for several /boot subvols,
97 # becuase I keep a minimal debian install on it, for
98 # recovery needs, and for doing pxe-kexec.
99 boot_mib=10000
100
101
102 ##### end configuration
103
104
105 add-part() { # add partition suffix to $dev
106 local d ret
107 if [[ $# == 1 ]]; then
108 d=$dev
109 part=$1
110 else
111 d=$1
112 part=$2
113 fi
114 if [[ $d == /dev/disk/by-id/* ]]; then
115 ret=$d-part$part
116 else
117 ret=$d$part
118 fi
119 echo $ret
120 }
121
122 bootdev() { add-part $@ $bootn; }
123 rootdev() { add-part $@ $rootn; }
124 swapdev() { add-part $@ $swapn; }
125 grub_extdev() { add-part $@ $grub_extn; }
126 bios_grubdev() { add-part $@ $bios_grubn; }
127
128 crypt-dev() { echo /dev/mapper/crypt_dev_${1##*/}; }
129 crypt-name() { echo crypt_dev_${1##*/}; }
130 root-cryptdev() { crypt-dev $(rootdev $@); }
131 swap-cryptdev() { crypt-dev $(swapdev $@); }
132 root-cryptname() { crypt-name $(rootdev $@); }
133 swap-cryptname() { crypt-name $(swapdev $@); }
134
135 ##### end function defs
136
137 if ifclass REPARTITION;then
138 partition=true # force a full wipe
139 else
140 partition=false # change to true to force a full wipe
141 fi
142
143
144
145 hdds=()
146 ssds=()
147 cd /sys/block
148 for disk in [sv]d[a-z]; do
149 case $(cat $disk/queue/rotational) in
150 0) ssds+=(/dev/$disk) ;;
151 1) hdds+=(/dev/$disk) ;;
152 *) echo "$0: error: unknown /sys/block/$disk/queue/rotational: \
153 $(cat $disk/queue/rotational)"; exit 1 ;;
154 esac
155 done
156
157 # install all ssds, or if there are none, all hdds.
158 # Note, usb flash disks are seen as rotational, which is
159 # very odd, but convenient for ignoring them here.
160 # TODO: find a reliable way to ignore them.
161 if ! ifclass ROTATIONAL && (( ${#ssds[@]} > 0 )); then
162 short_devs=( ${ssds[@]} )
163 else
164 short_devs=( ${hdds[@]} )
165 fi
166
167 # check if the partitions exist have the right filesystems
168 #blkid="$(blkid -s TYPE)"
169 for dev in ${short_devs[@]}; do
170 if $partition; then break; fi
171 y=$(readlink -f $dev)
172 arr=($y[0-9])
173 [[ ${#arr[@]} == "${lastn}" ]] || partition=true
174 for (( i=1; i <= lastn; i++ )); do
175 [[ -e ${dev}$i ]] || partition=true
176 done
177 # On one system, blkid is missing some partitions.
178 # maybe we need a flag, like FUZZY_BLKID or something, so we
179 # can check that at least some exist.
180 # for x in "`rootdev`: TYPE=\"crypto_LUKS\"" "`bootdev`: TYPE=\"btrfs\""; do
181 # echo "$blkid" | grep -Fx "$x" &>/dev/null || partition=true
182 # done
183 done
184
185 if $partition && ifclass PARTITION_PROMPT; then
186 echo "Press any key except ctrl-c to continue and partition these drives:"
187 echo " ${short_devs[*]}"
188 read -r
189 fi
190
191 devs=()
192 shopt -s extglob
193 for short_dev in ${short_devs[@]}; do
194 devs+=($(devbyid $short_dev))
195 done
196 if [[ ! ${devs[@]} ]]; then
197 echo "$0: error: failed to detect devs" >&2
198 exit 1
199 fi
200
201
202 first=false
203 boot_devs=()
204 for dev in ${devs[@]}; do
205 if ifclass frodo; then
206 # I ran into a machine where the bios doesn't know about some disks,
207 # so 1st stage of grub also doesn't know about them.
208 # Also, grub does not support mounting degraded btrfs as far as
209 # I can tell with some googling.
210 # From within an arch install env, I could detect them by noting
211 # their partitions were mixed with the next disk in /dev/disk/by-path,
212 # and I have mixed model disks, and I could see the 8 models which showed
213 # up in the bios, and thus see which 2 models were missing.
214 # hdparm -I /dev/sdh will give model info in linux.
215 # However, in fai on jessie, /dev/disk/by-path dir doesn't exist,
216 # and I don't see another way, so I'm hardcoding them.
217 # We still put grub on them and partition them the same, for uniformity
218 # and in case they get moved to a system that can recognize them,
219 # we just exclude them from the boot filesystem.
220 cd /dev/disk/by-id/
221 bad_disk=false
222 for id in ata-TOSHIBA_MD04ACA500_8539K4TQFS9A \
223 ata-TOSHIBA_MD04ACA500_Y5IFK6IJFS9A; do
224 if [[ $(readlink -f $id) == "$(readlink -f $dev)" ]]; then
225 bad_disk=true
226 break
227 fi
228 done
229 $bad_disk || boot_devs+=(`bootdev`)
230 else
231 boot_devs+=(`bootdev`)
232 fi
233 if [[ $boot_devs && $first ]]; then
234 first_grub_extdev=`grub_extdev`
235 first=false
236 fi
237 done
238
239 if ifclass RAID0 || (( ${#boot_devs[@]} == 1 )); then
240 raid_level=0
241 elif ifclass RAID1 || (( ${#boot_devs[@]} <= 3 )); then
242 raid_level=1
243 else
244 raid_level=10
245 # need double the space if we are raid 10, and then
246 # might as well give some extra.
247 boot_mib=$((boot_mib * 3))
248 fi
249
250
251
252 if [[ ! $DISTRO ]]; then
253 if ifclass VOL_STRETCH_BOOTSTRAP; then
254 DISTRO=debianstretch_bootstrap
255 elif ifclass VOL_STRETCH; then
256 DISTRO=debianstretch
257 elif ifclass VOL_BUSTER; then
258 DISTRO=debianbuster
259 elif ifclass VOL_TESTING; then
260 DISTRO=debiantesting
261 elif ifclass VOL_XENIAL; then
262 DISTRO=ubuntuxenial
263 elif ifclass VOL_BELENOS; then
264 DISTRO=trisquelbelenos
265 elif ifclass VOL_FLIDAS; then
266 DISTRO=trisquelflidas
267 elif ifclass VOL_ETIONA; then
268 DISTRO=trisqueletiona
269 else
270 echo "PARTITIONER ERROR: no distro class/var set" >&2
271 exit 1
272 fi
273 fi
274 first_boot_dev=${boot_devs[0]}
275
276
277 bpart() { # btrfs a partition
278 case $raid_level in
279 0) mkfs.btrfs -f $@ ;;
280 1) mkfs.btrfs -f -m raid1 -d raid1 $@ ;;
281 10) mkfs.btrfs -f -m raid10 -d raid10 $@ ;;
282 esac
283 }
284
285
286 # keyfiles generated like:
287 # head -c 2048 /dev/urandom | od | s dd of=/q/root/luks/host-demohost
288 luks_dir=${LUKS_DIR:-/var/lib/fai/config/distro-install-common/luks}
289
290 if [[ ! -e $luks_dir/host-$HOSTNAME ]]; then
291 echo "$0: error: no key for hostname at $luks_dir/host-$HOSTNAME" >&2
292 exit 1
293 fi
294
295 lukspw=$(cat $luks_dir/iank)
296 # # ian: disabled by chaning to tpnew while I use the tp host.
297 # # note, corresponding changes in /b/ds/keyscript-{on,off}
298 if ifclass tpnew; then
299 lukspw=$(cat $luks_dir/traci)
300 fi
301 if ifclass ziva; then
302 lukspw=$(cat $luks_dir/ziva)
303 fi
304 if ifclass demohost; then
305 lukspw=x
306 fi
307
308
309 first_root_crypt=$(root-cryptdev ${devs[0]})
310
311 # 1.5 x based on https://access.redhat.com/documentation/en-US/Red_Hat_Enterprise_Linux/7/html/Installation_Guide/sect-disk-partitioning-setup-x86.html#sect-custom-partitioning-x86
312 swap_mib=$(( $(grep ^MemTotal: /proc/meminfo | \
313 awk '{print $2}') * 3/(${#devs[@]} * 2 ) / 1024 ))
314
315 mkdir -p /tmp/fai
316 root_devs=()
317 for dev in ${devs[@]}; do
318 root_devs+=(`rootdev`)
319 done
320 shopt -s nullglob
321 if $partition; then
322
323 ### begin wipefs
324 if [[ ! $SPECIAL_DISK ]]; then
325 for dev in ${devs[@]}; do
326 # if we repartition to the same as an old partition,
327 # we don't want any old fses hanging around.
328 for (( i=1; i <= lastn; i++ )); do
329 x=$(add-part $dev $i)
330 [[ -e $x ]] || continue
331 count_down=10
332 # wipefs has failed, manual run works, google suggests timing issue
333 while ! wipefs -a $x; do
334 sleep 2
335 count_down=$((count_down - 1))
336 (( count_down > 0 )) || exit 1
337 done
338 done
339 done
340 fi
341 ### end wipefs
342
343 for dev in ${devs[@]}; do
344 if [[ $SPECIAL_DISK ]]; then
345 dev=$(devbyid $SPECIAL_DISK)
346 fi
347
348 # parted will round up the disk size. Do -1 so we can have
349 # fully 1MiB unit partitions for easy resizing of the last partition.
350 # Otherwise we would pass in -0 for the end argument for the last partition.
351 #
352 # Note: parted print error output is expected. example:
353 # Error: /dev/vda: unrecognised disk label
354 disk_mib=$(( $(parted -m $dev unit MiB print | \
355 sed -nr "s#^/dev/[^:]+:([0-9]+).*#\1#p") - 1))
356 root_end=$(( disk_mib - swap_mib - boot_mib / ${#boot_devs[@]} ))
357 swap_end=$(( root_end + swap_mib))
358
359 parted -s $dev mklabel gpt
360 # MiB because parted complains about alignment otherwise.
361 pcmd="parted -a optimal -s -- $dev"
362 $pcmd mkpart primary ext3 12MiB ${root_end}MiB
363 # without naming, systemd gives us misc errors like:
364 # dev-disk-by\x2dpartlabel-primary.device: Dev dev-disk-by\x2dpartlabel-primary.device appeared twice
365 $pcmd name $rootn root
366 # normally a swap is type "linux-swap", but this is encrypted swap. using that
367 # label will confuse systemd.
368 $pcmd mkpart primary "" ${root_end}MiB ${swap_end}MiB
369 $pcmd name $swapn swap
370 $pcmd mkpart primary "" ${swap_end}MiB ${disk_mib}MiB
371 $pcmd name $bootn boot
372 # i only need a few k, but googling min size,
373 # I found someone saying that gparted required
374 # required at least 8 because of their hard drive cylinder size.
375 # And 8 is still very tiny.
376 $pcmd mkpart primary "ext2" 4MiB 12MiB
377 $pcmd name $grub_extn grubext
378 # gpt ubuntu cloud image uses ~4 mb for this partition. fai uses 1 MiB.
379 # so, I use 3, whatever.
380 # note: parted manual saying cheap flash media
381 # should to start at 4.
382 $pcmd mkpart primary "" 1MiB 4MiB
383 $pcmd name $bios_grubn biosgrub
384 $pcmd set $bios_grubn bios_grub on
385 $pcmd set $bootn boot on # generally not needed on modern systems
386 # the mkfs failed before on a vm, which prompted me to add
387 # sleep .1
388 # then it failed again on a physical machine
389 # with:
390 # Device /dev/disk/by-id/foo doesn't exist or access denied,
391 # so I added a wait until it existed.
392 # Then I added the mkfs.ext2, which claimed to succeed,
393 # but then couldn't be found upon reboot. In that case we didn't
394 # wait at all. So I've added a 3 second minimum wait.
395 sleep 3
396 secs=0
397 while [[ ! -e `rootdev` ]] && (( secs < 10 )); do
398 sleep 1
399 secs=$((secs +1))
400 done
401 # Holds just a single file, rarely written, so
402 # use ext2, like was often used for the /boot partition.
403 # This exists because grub can only persist data to a non-cow fs.
404 # And we use persisting a var in grub to do a one time boot.
405 # We could pass the data on the kernel command line and persist it
406 # to grubenv after booting, but that relies on the boot always succeeding.
407 # This is just a bit more robust, and it could work for booting
408 # into ipxe which can't persist data, if we ever got that working.
409 mkfs.ext2 `grub_extdev`
410 # when we move to newer than trisquel 8, we can remove
411 # --type luks1. We can also check on cryptsetup --help | less /compil
412 # to see about the other settings. Default in debian 9 is luks2.
413 # You can convert from luks2 to luks 1 by adding a temporary key:
414 # cryptsetup luksAddKey --pbkdf pbkdf2
415 # then remove the new format keys with cryptsetup luksRemoveKey
416 # then cryptsetup convert DEV --type luks1, then readd old keys and remove temp.
417 yes YES | cryptsetup luksFormat `rootdev` $luks_dir/host-$HOSTNAME \
418 --type luks1 -c aes-cbc-essiv:sha256 -s 256 || [[ $? == 141 ]]
419 yes "$lukspw" | \
420 cryptsetup luksAddKey --key-file $luks_dir/host-$HOSTNAME \
421 `rootdev` || [[ $? == 141 ]]
422 # background: Keyfile and password are treated just
423 # like 2 ways to input a passphrase, so we don't actually need to have
424 # different contents of keyfile and passphrase, but it makes some
425 # security sense to a really big randomly generated passphrase
426 # as much as possible, so we have both.
427 #
428 # This would remove the keyfile.
429 # yes 'test' | cryptsetup luksRemoveKey /dev/... \
430 # /key/file || [[ $? == 141 ]]
431
432 cryptsetup luksOpen `rootdev` `root-cryptname` \
433 --key-file $luks_dir/host-$HOSTNAME
434
435 if [[ $SPECIAL_DISK ]]; then
436 exit 0
437 fi
438 done
439 ls -la /dev/btrfs-control # this was probably for debugging...
440 sleep 1
441 bpart $(for dev in ${devs[@]}; do root-cryptdev; done)
442 bpart ${boot_devs[@]}
443 else
444 for dev in ${devs[@]}; do
445 mkfs.ext2 `grub_extdev`
446 cryptsetup luksOpen `rootdev` `root-cryptname` \
447 --key-file $luks_dir/host-$HOSTNAME
448 done
449 sleep 1
450 fi
451
452
453 if [[ $DISTRO != debianstretch_bootstrap ]]; then
454 # bootstrap distro doesn't use separate encrypted root.
455 mount -o subvolid=0 $first_root_crypt /mnt
456 # systemd creates subvolumes we want to delete.
457 s=($(btrfs subvolume list --sort=-path /mnt |
458 sed -rn "s#^.*path\s*(root_$DISTRO/\S+)\s*\$#\1#p"))
459 for subvol in ${s[@]}; do btrfs subvolume delete /mnt/$subvol; done
460 btrfs subvolume set-default 0 /mnt
461 [[ ! -e /mnt/root_$DISTRO ]] || btrfs subvolume delete /mnt/root_$DISTRO
462
463 ## create subvols ##
464 cd /mnt
465
466 btrfs subvolume create root_$DISTRO
467
468 mkdir -p /mnt/root_$DISTRO/boot
469 # could set default subvol like this, but no reason to.
470 # btrfs subvolume set-default \
471 # $(btrfs subvolume list . | grep "root_$DISTRO$" | awk '{print $2}') .
472
473 # no cow on the root filesystem. it's setup is fully scripted,
474 # if it's messed up, we will just recreated it,
475 # and we can get better perf with this.
476 # I can't remember exactly why, but this is preferable to mounting with
477 # -o nodatacow, I think because subvolumes inherit that.
478 chattr -Rf +C root_$DISTRO
479 cd /
480 umount /mnt
481 fi
482
483 mount -o subvolid=0 $first_boot_dev /mnt
484 cd /mnt
485 btrfs subvolume set-default 0 /mnt # already default, just ensuring it.
486
487 # for libreboot systems. grub2 only reads from subvolid=0
488 mkdir -p /mnt/grub2
489 cp $FAI/distro-install-common/libreboot_grub.cfg /mnt/grub2
490
491 if [[ $DISTRO == debianstretch_bootstrap ]]; then
492 # this is just convenience for the libreboot_grub config
493 # so we can glob the other ones easier.
494 boot_vol=$DISTRO
495 else
496 boot_vol=boot_$DISTRO
497 fi
498 [[ ! -e /mnt/$boot_vol ]] || btrfs subvolume delete /mnt/$boot_vol
499 btrfs subvolume create $boot_vol
500 cd /
501 umount /mnt
502 ## end create subvols ##
503
504 dev=${boot_devs[0]}
505 mount $first_grub_extdev /mnt
506 grub-editenv /mnt/grubenv set did_fai_check=true
507 grub-editenv /mnt/grubenv set last_boot=/$boot_vol
508 umount /mnt
509
510 if [[ $DISTRO == debianstretch_bootstrap ]]; then
511 cat > /tmp/fai/fstab <<EOF
512 $first_boot_dev / btrfs noatime,subvol=$boot_vol 0 0
513 EOF
514 cat >/tmp/fai/disk_var.sh <<EOF
515 BOOT_DEVICE="${short_devs[@]}"
516 ROOT_PARTITION=$first_boot_dev
517 EOF
518 else
519 # note, fai creates the mountpoints listed here
520 cat > /tmp/fai/fstab <<EOF
521 $first_root_crypt / btrfs noatime,subvol=root_$DISTRO 0 0
522 $first_root_crypt /mnt/root btrfs noatime,subvolid=0 0 0
523 $first_boot_dev /boot btrfs noatime,subvol=$boot_vol 0 0
524 EOF
525 swaps=()
526 for dev in ${devs[@]}; do
527 swaps+=(`swap-cryptname`)
528 cat >>/tmp/fai/crypttab <<EOF
529 `root-cryptname` `rootdev` none keyscript=/root/keyscript,discard,luks
530 `swap-cryptname` `swapdev` /dev/urandom swap,cipher=aes-xts-plain64,size=256,hash=ripemd160
531 EOF
532 cat >> /tmp/fai/fstab <<EOF
533 `swap-cryptdev` none swap sw 0 0
534 EOF
535 done
536
537 # fai would do this:
538 #BOOT_DEVICE=\${BOOT_DEVICE:-"${devs[0]}"}
539
540 # note: swaplist seems to do nothing.
541 cat >/tmp/fai/disk_var.sh <<EOF
542 BOOT_DEVICE="${short_devs[@]}"
543 BOOT_PARTITION=\${BOOT_PARTITION:-$first_boot_dev}
544 # ROOT_PARTITIONS is added by me, used in arch setup.
545 ROOT_PARTITIONS="${root_devs[@]}"
546 ROOT_PARTITION=\${ROOT_PARTITION:-$first_root_crypt}
547 SWAPLIST=\${SWAPLIST:-"${swaps[@]}"}
548 EOF
549 fi